"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var ChainGunLink_1 = require("./ChainGunLink");
var diffGunCRDT_1 = require("./diffGunCRDT");
var GunGraph_1 = require("./GunGraph");
var chaingun_1 = require("./@notabug/chaingun");
var ChainGun = /** @class */ (function () {
    function ChainGun(opt, LinkClass) {
        if (LinkClass === void 0) { LinkClass = ChainGunLink_1.ChainGunLink; }
        if (opt && opt.graph) {
            this.graph = opt.graph;
        }
        else {
            this.graph = new GunGraph_1.GunGraph();
            this.graph.use(diffGunCRDT_1.diffGunCRDT);
            this.graph.use(diffGunCRDT_1.diffGunCRDT, 'write');
        }
        this._opt = {};
        if (opt)
            this.opt(opt);
        this.LinkClass = LinkClass;
    }
    ChainGun.prototype.opt = function (options) {
        var _this = this;
        this._opt = __assign(__assign({}, this._opt), options);
        if (options.peers) {
            options.peers.forEach(function (peer) {
                return _this.graph.connect(new chaingun_1.WebSocketGraphConnector(peer, _this._opt.WS));
            });
        }
        return this;
    };
    /**
     * Traverse a location in the graph
     *
     * @param key Key to read data from
     * @param cb
     * @returns New chain context corresponding to given key
     */
    ChainGun.prototype.get = function (soul, cb) {
        return new this.LinkClass(this, soul);
    };
    return ChainGun;
}());
exports.ChainGun = ChainGun;
//# sourceMappingURL=ChainGun.js.map