"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var GunEvent = /** @class */ (function () {
    function GunEvent(name) {
        if (name === void 0) { name = 'GunEvent'; }
        this.name = name;
        this._listeners = [];
        this.listenerCount = this.listenerCount.bind(this);
        this.on = this.on.bind(this);
        this.off = this.off.bind(this);
        this.trigger = this.trigger.bind(this);
    }
    GunEvent.prototype.listenerCount = function () {
        return this._listeners.length;
    };
    GunEvent.prototype.on = function (cb) {
        if (this._listeners.indexOf(cb) !== -1)
            return;
        this._listeners.push(cb);
    };
    GunEvent.prototype.off = function (cb) {
        var idx = this._listeners.indexOf(cb);
        if (idx !== -1)
            this._listeners.splice(idx, 1);
    };
    GunEvent.prototype.reset = function () {
        this._listeners = [];
    };
    GunEvent.prototype.trigger = function (a, b, c) {
        this._listeners.forEach(function (cb) { return cb(a, b, c); });
    };
    return GunEvent;
}());
exports.GunEvent = GunEvent;
//# sourceMappingURL=GunEvent.js.map