"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var mergeGunNodes_1 = require("./mergeGunNodes");
var diffGunCRDT_1 = require("./diffGunCRDT");
var addMissingState_1 = require("./addMissingState");
function nodeToGraph(node) {
    var _a;
    var modified = __assign({}, node);
    var nodes = {};
    var nodeSoul = node && node._ && node._['#'];
    for (var key in node) {
        if (key === '_')
            continue;
        var val = node[key];
        if (typeof val !== 'object')
            continue;
        var soul = val && val._ && val._['#'];
        if (soul) {
            var edge = { '#': soul };
            modified[key] = edge;
            var graph = addMissingState_1.addMissingState(nodeToGraph(val));
            var diff_1 = diffGunCRDT_1.diffGunCRDT(graph, nodes);
            nodes = diff_1 ? mergeGunNodes_1.mergeGraph(nodes, diff_1) : nodes;
        }
    }
    var raw = (_a = {}, _a[nodeSoul] = modified, _a);
    var withMissingState = addMissingState_1.addMissingState(raw);
    var diff = diffGunCRDT_1.diffGunCRDT(withMissingState, nodes);
    nodes = diff ? mergeGunNodes_1.mergeGraph(nodes, diff) : nodes;
    return nodes;
}
exports.nodeToGraph = nodeToGraph;
function flattenGraphData(data) {
    var graphs = [];
    var flatGraph = {};
    for (var soul in data) {
        var node = data[soul];
        if (node)
            graphs.push(nodeToGraph(node));
    }
    for (var i = 0; i < graphs.length; i++) {
        var diff = diffGunCRDT_1.diffGunCRDT(graphs[i], flatGraph);
        flatGraph = diff ? mergeGunNodes_1.mergeGraph(flatGraph, diff) : flatGraph;
    }
    return flatGraph;
}
exports.flattenGraphData = flattenGraphData;
//# sourceMappingURL=flattenGraphData.js.map