import { GunEvent } from './GunEvent';
import { GunGraphConnector } from './GunGraphConnector';
interface GunGraphOptions {
}
export declare class GunGraph {
    graphData: GunEvent<GunGraphData>;
    private _opt;
    private _connectors;
    private _readMiddleware;
    private _writeMiddleware;
    private _graph;
    private _listeners;
    constructor();
    opt(options: GunGraphOptions): this;
    connect(connector: GunGraphConnector): this;
    disconnect(connector: GunGraphConnector): this;
    /**
     * Register graph middleware
     *
     * @param middleware The middleware function to add
     * @param kind Optionaly register write middleware instead of read by passing "write"
     */
    use(middleware: ChainGunMiddleware, kind?: ChainGunMiddlewareType): this;
    /**
     * Unregister graph middleware
     *
     * @param middleware The middleware function to remove
     * @param kind Optionaly unregister write middleware instead of read by passing "write"
     */
    unuse(middleware: ChainGunMiddleware, kind?: ChainGunMiddlewareType): this;
    query(path: string[], cb: GunOnCb): () => void;
    putPath(path: string[], data: GunValue, cb?: GunPutCb): (() => void) | undefined;
    /**
     * Write node data
     *
     * @param data one or more gun nodes keyed by soul
     */
    put(data: GunGraphData, cb?: GunPutCb): Promise<void>;
    /**
     * Update node data in this chain from some local or external source
     *
     * @param soul soul of node to update
     * @param data node data to include
     */
    private receiveNodeData;
    private _forget;
    private _request;
    private _listen;
    private _unlisten;
    private _getPathData;
}
export {};
